=== debian/changelog ===
solvespace (3.0.rc1+repack1-4) unstable; urgency=medium

  * [3fa5dd1] Remove arm-patch

 -- Anton Gladky <gladk@debian.org>  Fri, 15 Jan 2021 15:40:02 +0100

solvespace (3.0.rc1+repack1-3) unstable; urgency=medium

  * [fa2ba63] Use CXX for mimalloc compilation

 -- Anton Gladky <gladk@debian.org>  Thu, 14 Jan 2021 23:41:14 +0100

solvespace (3.0.rc1+repack1-2) unstable; urgency=medium

  * [7192813] Update d/copyright
  * [93f958e] Fix compilation on armel

 -- Anton Gladky <gladk@debian.org>  Thu, 14 Jan 2021 19:41:26 +0100

solvespace (3.0.rc1+repack1-1) unstable; urgency=medium

  * [2c974c1] New upstream version 3.0.rc1+repack1
  * [d29ee68] Update get_orig script
  * [73cbc23] Refresh patches
  * [d8e0c6c] Use gtk3. (Closes: #967751)
  * [09453c9] Update watch file format version to 4.
  * [70475f7] Set Standards-Version to 4.5.1

 -- Anton Gladky <gladk@debian.org>  Tue, 12 Jan 2021 23:27:41 +0100
